Show last authors
1 {{box cssClass="floatinginfobox" title="**Contents**"}}
2 {{toc/}}
3 {{/box}}
4
5 (% class="label label-default" %)Note 1(%%) XWiki provides migration paths to upgrade from any older version to any newer one. You don't need to upgrade to intermediary versions.
6
7 (% class="label label-default" %)Note 2(%%) It's also good to check the [[Release Notes>>xwiki:ReleaseNotes.WebHome]] for the versions between your old version and the new version you're upgrading to. You should pay an extra care about the section in the release notes entitled ##"Issues specific to XWiki <version>"##.
8
9 (% class="label label-primary" %)Backup(%%) Before you proceed, be sure to [[backup>>xwiki:Documentation.AdminGuide.Backup]] all of your data, just in case something goes wrong with the update / downgrade. Depending on your usage, you should be backing up your information regularly.
10
11 = Upgrading =
12
13 Keep your XWiki instance up to date to benefit from the best new features and keep your data safe from security threats. There are multiple methods to upgrade XWiki depending on how many data you need to migrate or how experienced you are with different tools.
14
15 In the majority of cases an upgrade consists of two parts:
16
17 * Part 1: Upgrading the //distribution// on the //server / filesystem// and
18 * Part 2: Upgrading the //flavor (wiki pages)// from a //browser//.
19
20 ----
21
22 == (% class="label label-primary" %)Part 1(%%) Upgrading the distribution ==
23
24 === (% class="label label-default" %)Method 1.A(%%) Upgrading from the Debian package (% class="badge fill-gray pull-right" id="HUpgradingfromtheDebianpackage" %).DEB(%%) ===
25
26 * (((
27 Update packages index:
28
29 {{code language="bash"}}
30 sudo apt-get update
31 {{/code}}
32 )))
33
34 * (((
35 Package upgrade:
36
37 {{code language="bash"}}
38 sudo apt-get upgrade
39 {{/code}}
40
41 This will upgrade all packages, not just XWiki. If you want to avoid all the other packages and only update XWiki, you can use {{code}}sudo apt-get install xwiki-tomcat8-mysql{{/code}} (change xwiki-tomcat8-mysql for the top level package you installed if you installed something else).
42
43 {{warning}}
44 When upgrading from pre 9.5 version {{code}}apt-get upgrade{{/code}} won't find anything because the package name changed ([[XWiki Enterprise does not exist anymore>>xwiki:Blog.XWiki Enterprise is dead, long live XWiki!]]).
45
46 All you have to do in this case is install the ##xwiki-tomcat*## package corresponding to the top level ##xwiki-enterprise-tomcat*## one you installed previously. For example if you had ##xwiki-enterprise-tomcat8-mysql## 9.4 you should do {{code}}sudo apt-get install xwiki-tomcat8-mysql{{/code}}.
47 {{/warning}}
48 )))
49
50 * (((
51 Pages upgrade:
52
53 However after upgrading you still need to install the new UI; see next step [[Upgrading the flavor>>.||anchor="HPart2Upgradingtheflavor"]] below.
54 )))
55
56 === (% class="label label-default" %)Method 1.B(%%) Upgrading from Docker (% class="badge fill-gray pull-right" %).Docker(%%) ===
57
58 * If you've installed XWiki by using the official XWiki Docker image, [[follow the instructions there>>https://github.com/xwiki-contrib/docker-xwiki/blob/master/README.md#upgrading-xwiki]] for upgrading it.
59
60 === (% class="label label-default" %)Method 1.C(%%) Upgrading the webapp (% class="badge fill-gray pull-right" %).WAR(%%) ===
61
62 * The general strategy is to [[download the new WAR distribution>>xwiki:Main.Download]] and to replace your current installed WAR with it. However make sure you don't copy on top since this could leave some old files around which would make XWiki fail (like if old JARs are lying around in ##WEB-INF/lib##). In addition you would override some XWiki configuration files located in ##WEB-INF## (##xwiki.properties## and ##xwiki.cfg## to name just two).
63
64 * Thus, before replacing your current WAR, make sure you [[back it up, including configuration and data files>>xwiki:Documentation.AdminGuide.Backup]].
65
66 * (((
67 Also you need to ensure that you use the same XWiki Permanent directory (configured in ##WEB-INF/xwiki.properties## using the ##environment.permanentDirectory## property). {{warning}}Best is to not copy the ##solr/## subdirectory since the SOLR schema could have changed and it's best to let XWiki reindex using the new schema{{/warning}}
68 )))
69
70 * Some additional operations may be required for upgrading and you must check the [[release notes>>xwiki:ReleaseNotes.WebHome]] for all the versions from the version you're upgrading from up to the new version you're installing. It's also possible that new features are available and that some configuration files need to be modified. If this is the case then it'll be specified in the release notes.
71
72 * {{include reference="xwiki:Documentation.AdminGuide.UpgradeDatabase"/}}
73
74 * (((
75 **Invalid Extensions**
76
77 Also note that when you upgrade, some extensions that were previously valid may become invalid (for example they may have been renamed, removed or have versions that do not match the version of the WAR you've installed as is the case with the example below). In this case you'll see in the console messages such as:
78
79 {{code language="noformat"}}
80 2013-12-02 11:43:01,688 [localhost-startStop-1] WARN ltInstalledExtensionRepository - Invalid extension [org.xwiki.enterprise:xwiki-enterprise-ui-common-5.2.1] on namespace [wiki:xwiki]
81 2013-12-02 11:43:01,688 [localhost-startStop-1] WARN ltInstalledExtensionRepository - Invalid extension [org.xwiki.platform:xwiki-platform-workspace-ui-5.2.1] on namespace [wiki:xwiki]
82 2013-12-02 11:43:01,688 [localhost-startStop-1] WARN ltInstalledExtensionRepository - Invalid extension [org.xwiki.enterprise:xwiki-enterprise-ui-mainwiki-5.2.1] on namespace [wiki:xwiki]
83 2013-12-02 11:43:01,689 [localhost-startStop-1] WARN ltInstalledExtensionRepository - Invalid extension [org.xwiki.enterprise:xwiki-enterprise-ui-wiki-all-5.2.1] on namespace [wiki:workspacetemplate]
84 {{/code}}
85
86 These are just warnings and don't affect that stability of your instance. Actually the Distribution Wizard you get (see the next section on "Upgrading wiki documents") will ask you to upgrade those invalid extensions and will remove the old versions that became invalid.
87 )))
88
89 * After upgrading you still need to install the new UI; see next step [[Upgrading the flavor>>.||anchor="HPart2Upgradingtheflavor"]] below.
90
91 === (% class="label label-default" %)Method 1.D(%%) Upgrading the demo package (% class="badge fill-gray pull-right" %).ZIP(%%) ===
92
93 * If you've installed the standard distribution (##zip## or ##jar## distribution) and you wish to upgrade it, the simplest is to [[download>>xwiki:Main.Download]] the new version and install it as you did the first time. Just make sure you don't install the new version over the old one (both installations need to exist).
94
95 * Then copy [[the configuration files and the permanent directory>>xwiki:Documentation.AdminGuide.Backup]] from the old installation to the new one ({{warning}}Best is to not copy the ##solr/## subdirectory since the SOLR schema could have changed and it's best to let XWiki reindex using the new schema{{/warning}}). Ideally you should not copy over the configuration files exactly since the new version could have added new configuration options and thus ideally you should do a merge instead of a pure copy. Another strategy is to use the new configuration files, not copy over the old configuration files and instead manually edit the new configuration to make the same changes as you have may done before (If you've never touched the configuration files then there's nothing to do obviously!).
96
97 * (((
98 If you're on a unix system here are some commands that may help you doing the merge instead of doing it fully manually:
99
100 {{code language="none"}}
101 ## Note: We're assuming that "xwiki.new" is a symbolic link that points to the location
102 ## where the new xwiki version is located and that "xwiki" is the location of the previous
103 ## xwiki installation.
104 mv xwiki.new/WEB-INF/web.xml xwiki.new/WEB-INF/web.xml.ori; sudo sdiff xwiki/WEB-INF/web.xml xwiki.new/WEB-INF/web.xml.ori -B -W -E -o xwiki.new/WEB-INF/web.xml
105 mv xwiki.new/WEB-INF/xwiki.cfg xwiki.new/WEB-INF/xwiki.cfg.ori; sudo sdiff xwiki/WEB-INF/xwiki.cfg xwiki.new/WEB-INF/xwiki.cfg.ori -B -W -E -o xwiki.new/WEB-INF/xwiki.cfg
106 mv xwiki.new/WEB-INF/xwiki.properties xwiki.new/WEB-INF/xwiki.properties.ori; sudo sdiff xwiki/WEB-INF/xwiki.properties xwiki.new/WEB-INF/xwiki.properties.ori -B -W -E -o xwiki.new/WEB-INF/xwiki.properties
107 mv xwiki.new/WEB-INF/struts-config.xml xwiki.new/WEB-INF/struts-config.xml.ori; sudo sdiff xwiki/WEB-INF/struts-config.xml xwiki.new/WEB-INF/struts-config.xml.ori -B -W -E -o xwiki.new/WEB-INF/struts-config.xml
108 mv xwiki.new/WEB-INF/classes/logback.xml xwiki.new/WEB-INF/classes/logback.xml.ori; sudo sdiff xwiki/WEB-INF/classes/logback.xml xwiki.new/WEB-INF/classes/logback.xml.ori -B -W -E -o xwiki.new/WEB-INF/classes/logback.xml
109 {{/code}}
110 )))
111
112 * {{include reference="xwiki:Documentation.AdminGuide.UpgradeDatabase"/}}
113
114 * After upgrading you still need to install the new UI; see next step [[Upgrading the flavor>>.||anchor="HPart2Upgradingtheflavor"]] below.
115
116 ----
117
118 == (% class="label label-primary" id="HUpgradingwikidocuments" %)Part 2(%%) Upgrading the flavor ==
119
120 === Using Distribution Wizard ===
121
122 (% class="label label-success" %)Recommended(%%) The recommended way to upgrade an XWiki installation is to use the [[Distribution Wizard>>platform:Features.DistributionWizard]] which is automatically triggered after you upgrade the XWiki WAR. It allows you to automatically upgrade extensions installed in your wiki, supporting automatic merges and conflict resolution.
123
124 {{warning}}
125 Make sure you run the Distribution Wizard (DW) with a user having Programming Rights. The following pages require being saved by a user having Programming Rights to work correctly and they may happen to have been modified and thus the DW may need to modify them:
126
127 * ##AppWithinMinutes.DynamicMessageTool## (kept for backward-compatibility, not used)
128 * ##AnnotationCode.Style##
129 * ##AppWithinMinutes.LiveTableEditSheet##
130 * ##AppWithinMinutes.ClassEditSheet##
131 * [[##Main.Activity##>>http://jira.xwiki.org/browse/XWIKI-10446]]
132 * ##AnnotationCode.Script##
133 * ##XWiki.OfficeImporterAdmin##
134 * ##Filter.WebHome##
135 * ##XWiki.DeletedAttachments## (Fixed in XWiki 9.8RC1)
136 * ##XWiki.DeletedDocuments## (Fixed in XWiki 9.8RC1)
137 * ##WikiManager.Translations##
138
139 If you have already done the upgrade with a user not having Programming Rights, then log in with a user having those permissions (or ask someone who has them), [[navigate to those pages>>xwiki:FAQ.How can I navigate to a given page]], edit them (using the wiki editor preferably) and save them without any modification.
140 {{/warning}}
141
142 ----
143
144 == (% class="label label-default" %)Alternative(%%) Start fresh, plus Export and Reimport your data ==
145
146 There are cases when it's a better solution to [[export your current content as a XAR>>xwiki:Documentation.AdminGuide.ImportExport]] and [[reimport it>>xwiki:Documentation.AdminGuide.ImportExport]] into [[a new instance>>xwiki:Documentation.AdminGuide.Installation]]. For example this would be a good method if you have a very old version of XWiki and wish to move to a new version. You should use this method when you know exactly what content you have created and you manually check to not forget anything on the old instance.
147
148 Some tips:
149
150 * This method should work because the XWiki project takes great pride in being careful about backward compatibility and content created several years ago should still work well in new versions of XWiki. There are some configurations you need to change in case you have content written in the old [[XWiki Syntax 1.0>>extensions:Extension.Old XWiki 1\.0 syntax renderer]].
151 * Make sure to only import your own content pages and not the default XWiki pages since you’d overwrite the ones provided in new XWiki install.
152 * You may get issues when trying to export a large XAR. In that case you may want to try installing [[one of the Export Extensions>>extensions:Main.Tags||queryString="do=viewTag&tag=export"]] but you'll need to verify that the one you install will work on your old version of XWiki.
153
154 ----
155
156 = Downgrading =
157
158 {{warning}}
159 You should try to upgrade to a version that fixes the issue you're facing instead of downgrading. However if you really need to downgrade, read on...
160 {{/warning}}
161
162 A previous upgrade may have modified the database schema and the data saved in the permanent directory may also have incompatible changes. Thus the best strategy for downgrading is using the [[Alternative Method>>.||anchor="HAlternativeStartfresh2CplusExportandReimportyourdata"]], and that consists of [[exporting your wiki pages as XAR>>xwiki:Documentation.AdminGuide.Backup||anchor="HUsingtheXWikiExportfeature"]] (the ones having your content, not the default wiki pages provided by the XWiki distribution or installed Extensions). Then install the older XWiki version and re-install optional Extensions that you need. Then reimport your XAR in it.

Get Connected